Fuck LeetCode > Hash Table > 349. Intersection of Two Arrays > Solved in Java, Python, C++, JavaScript, C#, Go, Ruby > Repost or Contribute
LeetCode link: 349. Intersection of Two Arrays, difficulty: Easy.
Given two integer arrays nums1
and nums2
, return an array of their intersection.
Each element in the result must be unique and you may return the result in any order.
Array Intersection: The intersection of two arrays is defined as the set of elements that are present in both arrays.
Example 1:
Input: nums1 = [1,2,2,1], nums2 = [2,2]
Output: [2]
Example 2:
Input: nums1 = [4,9,5], nums2 = [9,4,9,8,4]
Output: [9,4]
Explanation: [4,9] is also accepted.
Constraints:
1 <= nums1.length, nums2.length <= 1000
0 <= nums1[i], nums2[i] <= 1000
Intuition
- Convert one of the arrays to a
set
. The elements are unique in aset
. - When traversing the other array, if an element is found to already exist in the
set
, it means that the element belongs to the intersection, and the element should be added to theresults
. - The
results
is also ofset
type because duplicate removal is required.
Complexity
Time complexity
O(N)
Space complexity
O(N)
Java #
class Solution {
public int[] intersection(int[] nums1, int[] nums2) {
var results = new HashSet<Integer>();
var num1Set = new HashSet<Integer>();
for (var num : nums1) {
num1Set.add(num);
}
for (var num : nums2) {
if (num1Set.contains(num)) {
results.add(num);
}
}
return results.stream().mapToInt(num -> num).toArray();
}
}
Python #
class Solution:
def intersection(self, nums1: List[int], nums2: List[int]) -> List[int]:
set_of_nums1 = set(nums1)
results = set()
for num in nums2:
if num in set_of_nums1:
results.add(num)
return list(results)
C++ #
class Solution {
public:
vector<int> intersection(vector<int>& nums1, vector<int>& nums2) {
unordered_set<int> results;
unordered_set<int> set_of_nums1(nums1.begin(), nums1.end());
for (auto num : nums2) {
if (set_of_nums1.contains(num)) {
results.insert(num);
}
}
return vector<int>(results.begin(), results.end());
}
};
JavaScript #
var intersection = function (nums1, nums2) {
let results = new Set()
let num1Set = new Set(nums1)
for (const num of nums2) {
if (num1Set.has(num)) {
results.add(num)
}
}
return Array.from(results)
};
C# #
public class Solution
{
public int[] Intersection(int[] nums1, int[] nums2)
{
var results = new HashSet<int>();
var num1Set = new HashSet<int>();
foreach (int num in nums1)
num1Set.Add(num);
foreach (int num in nums2)
{
if (num1Set.Contains(num))
{
results.Add(num);
}
}
return results.ToArray();
}
}
Go #
func intersection(nums1 []int, nums2 []int) []int {
results := map[int]bool{}
num1Set := map[int]bool{}
for _, num := range nums1 {
num1Set[num] = true
}
for _, num := range nums2 {
if _, ok := num1Set[num]; ok {
results[num] = true
}
}
return slices.Collect(maps.Keys(results))
}
Ruby #
def intersection(nums1, nums2)
nums1_set = Set.new(nums1)
results = Set.new
nums2.each do |num|
if nums1_set.include?(num)
results << num
end
end
results.to_a
end